<?php

namespace App\Connector\Components;

use Phalcon\Events\Event;

class ProductSaveAfterEvent extends \App\Core\Components\Base
{

    /**
     * @param Event $event
     * @param $myComponent
     */
    public function afterSave(Event $event, $myComponent,$data)
    {
        // $this->di->getLog()->logContent('Data = '.print_r($data,true),'info','save_after.log');
        try {
            

            $mongo = $this->di->getObjectManager()->get('\App\Core\Models\BaseMongo');
            $mongo->setSource($data['source_marketplace']."_product");
            $collection = $mongo->getCollection();
            if ( $collection->findOne(['source_product_id'=>$data['source_product_id']]) !== NULL ) 
                return true;
            $data=[
                 'user_id'=>$data['user_id'],
                 'source_product_id'=>$data['source_product_id'],
                 'container_id'=>$data['container_id']
                ];
            
                $collection->insertOne($data);
              
        } catch (Exception $e) {
            $this->di->getLog()->logContent('Errors : ' . $e->getMessage(),\Phalcon\Logger::CRITICAL,'product_after_save_exception.log');
        }
    }
}
