<?php

/**
 * CedCommerce
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the End User License Agreement (EULA)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://cedcommerce.com/license-agreement.txt
 *
 * @category    Ced
 * @package     Ced_Shoifyhome
 * @author      CedCommerce Core Team <connect@cedcommerce.com>
 * @copyright   Copyright CEDCOMMERCE (http://cedcommerce.com/)
 * @license     http://cedcommerce.com/license-agreement.txt
 */



namespace App\Connector\Models;

use App\Core\Models\Base;

class Fulfillment extends Base
{
    public function pushToQueue($handlerData)
    {

        $rmqHelper = $this->di->getObjectManager()->get('\App\Rmq\Components\Helper');
        return ['success' => true, 'data' => $rmqHelper->createQueue($handlerData['queue_name'], $handlerData)];
    }
    // public function fulfillment($user_id, $userData, $cbtId, $data)
    public function fulfillment($SqsData)
    {
        if ($SqsData['data']['activePage'] > 5) {
            return true;
        }
        echo "Inside \n";
        $paramsForProducts = [];
        $paramsForProducts['target_marketplace'] = $SqsData['data']['target_marketplace'];
        $paramsForProducts['activePage'] = $SqsData['data']['activePage'];
        $paramsForProducts['count'] = 50;
        $paramsForProducts['productOnly'] = true;
        $paramsForProducts['filter[marketplace.mercado_cbt.status][1]'] = 'active';


        $containerModel = new \App\Connector\Models\ProductContainer();
        $responseData = $containerModel->getProducts($paramsForProducts);
        foreach ($responseData['data']['rows'] as $product) {
            $cbtId = $product['marketplace']['mercado_cbt'][0]['target_product_id'];

            print_r($cbtId);
            echo "\n";
            $user_id = $SqsData['user_id'] ?? $this->di->getUser()->id;
            $userData = $SqsData['userData'] ?? $this->di->getObjectManager()->get("\App\Core\Models\User\Details")
                ->getDataByUserID($user_id, 'mercado_cbt');

            $mongo = $this->di->getObjectManager()->create('\App\Core\Models\BaseMongo');
            $collection = $mongo->getCollectionForTable('product_container');
            $collection2 = $mongo->getCollectionForTable('user_details');


            $params = [
                'shop_id' => $userData['remote_shop_id'],
                'item' => $cbtId
            ];

            $remoteResponse = $this->di->getObjectManager()->get("\App\Connector\Components\ApiClient")
                ->init('mercado_cbt', true)
                ->call('/items', [], $params, 'GET');

            foreach ($remoteResponse['data']['marketplace_items'] as $val) {
                $response = $this->di->getObjectManager()->get("\App\Connector\Components\ApiClient")
                    ->init('mercado_cbt', true)
                    ->call('/fulfillment/inventory', [], ['shop_id' => $userData['remote_shop_id'], 'item_id' => $val['item_id']], 'GET');
                $warehouse_id = '';
                $find = $collection2->aggregate([['$match' => ['user_id' => $user_id]], ['$project' => ['shops.warehouses' => 1, 'shops.remote_shop_id' => 1, 'shops.marketplace' => 1]]])->toArray();
                if ($find[0]['shops']) {
                    foreach ($find[0]['shops'] as $key => $value) {
                        if ($value['marketplace'] == 'mercado_cbt') {
                            foreach ($value['warehouses'] as $wareVal) {
                                if ($val['user_id'] === $wareVal['user_id']) {
                                    $warehouse_id = $wareVal['_id'];
                                }
                            }
                        }
                    }
                }

                $query = [
                    'user_id' => $user_id,
                    'marketplace.mercado_cbt.target_product_id' => $cbtId,
                    'marketplace.mercado_cbt.warehouse_id' => (int)$warehouse_id
                ];
                $set = ['$set' => [
                    "marketplace.mercado_cbt.$.fulfillment" => [
                        $response['data']
                    ]
                ]];
                $update = $collection->updateOne($query, $set);
                $count = $update->getModifiedCount();
                echo "Updated Count ->" . $count . "\n";
            }
        }

        if ($responseData['data']['next'] == null) {
            return true;
        }
        $SqsData['data']['activePage']++;
        $this->pushToQueue($SqsData);
    }
}
