<?php

namespace App\Connector\Models\Profile;

use App\Core\Models\BaseMongo;

class ProductHelper extends BaseMongo
{
    public $target_marketplace;
    public $profile_id;
    public $target_shop_id;
    public $warehouse_id;
    public $source_maketplace;
    public $process_data;
    public $source_shop_id;
    public $profile_data;
    public $source_shop_warehouse_id;
    public $container_ids;
    public $app_tag;


    public function requiredKey()
    {
        return [
            'profile_id',
            'target_marketplace',
            'target_shop_id',
            'warehouse_id',
            'source_maketplace',
            'source_shop_id',
            'source_shop_warehouse_id',
            'app_tag'
        ];
    }

    public function requiredKeyWithProductIds()
    {
        return [
            'target_marketplace',
            'target_shop_id',
            'warehouse_id',
            'source_maketplace',
            'source_shop_id',
            'source_shop_warehouse_id',
            'app_tag'
        ];
    }

    public function validateData()
    {
        $requiredKey = $this->requiredKey();

        foreach ($requiredKey as $key => $value) {
            if (isset($this->process_data[$value])) {
                $this->{$value} = $this->process_data[$value];
            } else {
                return ['success' => false, 'message' => "{$value} Key missing"];
            }
        }
    }

    public function validateDataWithProductIds()
    {
        $requiredKey = $this->requiredKeyWithProductIds();

        foreach ($requiredKey as $key => $value) {
            if (isset($this->process_data[$value])) {
                $this->{$value} = $this->process_data[$value];
            } else {
                return ['success' => false, 'message' => "{$value} Key missing"];
            }
        }
    }


    public function getProductByProfileId()
    {
        $start = microtime(true);
        $validateData = $this->validateData();
        if (isset($validateData['success']) && !$validateData['success']) {
            return $validateData;
        }

        $profileData = $this->getProfileData();

        if (!empty($profileData)) {
            $allProductData = $this->getProduct();
            if (isset($allProductData['success']) && !$allProductData['success']) {
                return $allProductData;
            }
            $productData = $allProductData['data'];
            $prepareProduct = $this->prepareProduct($productData);
            $prepareProduct['next'] = $allProductData['next'];
            $this->setTimeWithMessage($start, 'sending back to function', 'bulkupload');
            return $prepareProduct;
        } else {
            return ['success' => false, 'message' => 'profile data is empty'];
        }
    }

    public function prepareProfileAttribute()
    {
        $helperDataArr = [];
        $helperDataArr['profile_data'] = $this->profile_data;
        $helperDataArr['marketplace'] = $this->target_marketplace;
        $helperDataArr['source_marketplace'] = $this->source_maketplace;

        $profileHelperObj = new Helper();
        $profileHelperObj->process_data = $helperDataArr;
        $attributePath = "targets.{$this->target_marketplace}.shops.{$this->target_shop_id}.warehouses.{$this->warehouse_id}.sources.{$this->source_maketplace}.shops.{$this->source_shop_id}.warehouses.{$this->source_shop_warehouse_id}.attributes_mapping";

        $attributeRes = $profileHelperObj->getProfileAttribute($attributePath);

        return $attributeRes;
    }

    public function prepareProduct($productData)
    {

        $attributeRes = $this->prepareProfileAttribute();
        if (isset($productData[0]['global_attributes']) && $productData[0]['global_attributes'] === false) {
            $tempattributes = [];

            foreach ($productData[0]['marketplace_attributes'][0] as $key => $attributesHeader) {
                foreach ($attributesHeader as $attrKey => $attrvalue) {
                    if ($attrKey == "warranty_time" || $attrKey == "warranty_type"){
                        $tempattributes[$attrKey]=$attrvalue;
                    }
                    elseif (!empty($attrvalue['value'])) {
                        $attributeRes['data'][$attrKey]=$attrvalue;
                    }
                }
            }
        }

       

        if (isset($attributeRes['success'])) {
            $mappedAttributes = $attributeRes['data'];

            foreach ($productData as $productCol => $product) {
                $marketplaceIndex = $this->process_data['target_marketplace'] . "_marketplace";
                $editedAData = [];

                /* if (!empty($product[$marketplaceIndex])) {
                    foreach ($product[$marketplaceIndex] as $key => $maketplaceConatainerData) {
                        $editedAData[$maketplaceConatainerData['source_product_id']] = $maketplaceConatainerData;
                    }
                } else*/
                if (!empty($product['edited'])) {
                    $editedAData = $product['edited'];
                }

                if (!empty($editedAData) && isset($editedAData[$product['source_product_id']])) {
                    $product = array_merge($product, $editedAData);
                }
                $this->di->getLog()->logContent('$mapped attributes: ' . json_encode($mappedAttributes, 128), 'info', 'ShubhLog.log');
                foreach ($mappedAttributes as $columnName => $mappedData) {
                    $namespace = "\\App\\Connector\\Models\\Profile\\Attribute\\Type\\" . ucfirst($mappedData['type']);
                    if (class_exists($namespace)) {
                        $obj = new $namespace();
                        $product = $obj->changeData($columnName, $mappedData, $product);
                    }
                }

                

                $att_add_to_set = [];
                if (!empty($product['variants'])) {
                    foreach ($product['variants'] as $proCol => $variant) {

                        // if (!empty($editedAData) && isset($editedAData[$variant['source_product_id']])) {
                        //     $variant = array_merge($product, $editedAData[$variant['source_product_id']]);
                        // }
                        $editedAData = [];
                        if (!empty($variant['edited'])) {
                            $editedAData = $variant['edited'];
                            unset($variant['edited']);
                        }

                        if (!empty($editedAData)) {
                            $variant = array_merge($variant, $editedAData);
                        }
                        // unset($variant['variant_attributes']);
                        // $variant['variant_attributes'] = [];
                        foreach ($mappedAttributes as $columnName => $mappedData) {
                            $namespace = "\\App\\Connector\\Models\\Profile\\Attribute\\Type\\" . ucfirst($mappedData['type']);
                            if (class_exists($namespace)) {
                                $obj = new $namespace();
                                $variant = $obj->changeData($columnName, $mappedData, $variant);
                            }
                        }
                        foreach ($variant['variant_attributes'] as $value) {
                            if (!in_array($value, $att_add_to_set, true)) {
                                array_push($att_add_to_set, $value);
                            }
                        }
                        $product['variant_attributes'] = $att_add_to_set;
                        $product['variants'][$proCol] = $variant;
                    }

                    $newProductData[] = $product;
                } else {
                    $newProductData[] = $product;
                }
            }
        } else {
            $newProductData = $productData;
        }
        $this->di->getLog()->logContent('$newproductdata: ' . json_encode($newProductData, 128), 'info', 'ShubhLog.log');
        return ['success' => true, 'data' => $newProductData];
    }

    public function getProductByProductIds()
    {
        $start = microtime(true);
        $validateData = $this->validateDataWithProductIds();
        if (isset($validateData['success']) && !$validateData['success']) {
            return $validateData;
        }

        $productIds = $this->process_data['container_ids'];
        $finalQuery = [];

        $finalQuery[] = [
            '$match' => [
                'user_id' => $this->di->getUser()->id,
                'container_id' => ['$in' => $productIds],
            ]
        ];


        $commonQuery = $this->commonQuery();
        $finalQuery = array_merge($finalQuery, $commonQuery);
        $finalQuery = $this->apendToCommonQuery($finalQuery);

        $collection = $this->getCollectionForTable('product_container');
        $response = $collection->aggregate($finalQuery, ["typeMap" => ['root' => 'array', 'document' => 'array', 'object' => 'array', 'array' => 'array']]);
        //$this->di->getLog()->logContent('$response: ' . json_encode($response->toArray(), 128), 'info', 'ShubhLog.log');
        $response = $response->toArray();
        

        if (!empty($response)) {
            $profileWiseProduct = [];
            foreach ($response as $key => $productData) {
                if (isset($productData['profile'])) {
                    foreach ($productData['profile'] as $key => $profile) {
                        // if ($this->app_tag == $profile['app_tag']) {
                        $profileWiseProduct[$profile['profile_id']][] = $productData;
                        // }
                    }
                }
            }
            //$this->di->getLog()->logContent('$response: ' . json_encode($profileWiseProduct, 128), 'info', 'ShubhLog.log');
            

            if (!empty($profileWiseProduct)) {
                $prepareProductData = [];
                

                foreach ($profileWiseProduct as $profile_id => $products) {
                    $this->profile_id = $profile_id;
                    $profileData = $this->getProfileData();
                    if (!empty($profileData)) {
                        $prepareProduct = $this->prepareProduct($products);
                        $prepareProductData[] = $prepareProduct;
                    }
                }

                $this->setTimeWithMessage($start, 'profile wise data found');
                if (!empty($prepareProductData)) {
                    return ['success' => true, 'data' => $prepareProductData];
                } else {
                    return ['success' => false, 'message' => 'no profile wise data found 1'];
                }
            } else {
                $end = microtime(true);
                $timeTaken = $end - $start;
                $this->setTimeWithMessage($start, 'no profile wise data found 2');
                return ['success' => false, 'message' => 'no profile wise data found 2'];
            }
        } else {
            $this->setTimeWithMessage($start, 'no save data found');
            return ['success' => false, 'message' => 'no save data found'];
        }
    }


    public function setTimeWithMessage($start, $message = 'no profile wise data found 2', $log = 'uploadById')
    {
        $end = microtime(true);
        $timeTaken = $end - $start;
        if ($timeTaken <= 1) {
            return true;
        }
        $this->di->getLog()->logContent(
            $message .
                ', user_id : ' . $this->di->getUser()->id .
                ', time taken : ' . $timeTaken,
            'info',
            $log . '.log'
        );
    }


    public function getProduct()
    {
        $start = microtime(true);
        $finalQuery = [];

        $finalQuery[] = [
            '$match' => [
                'user_id' => $this->di->getUser()->id,
                'profile.profile_id' => $this->profile_id
            ]
        ];

        if (isset($this->process_data['page'], $this->process_data['limit'])) {
            $limit = (int) $this->process_data['limit'];
            $page = (int) $this->process_data['page'] - 1;
            $skip = ($limit * $page);
        } else {
            $skip = 0;
            $limit = 50;
        }
        $collection = $this->getCollectionForTable('product_container');

        $commonQuery = $this->commonQuery();
        $finalQuery = array_merge($finalQuery, $commonQuery);

        $finalQuery[] = [
            '$skip' => $skip,
        ];

        $finalQuery[] = [
            '$limit' => $limit + 1,
        ];

        $finalQuery = $this->apendToCommonQuery($finalQuery);
        $collection = $this->getCollectionForTable('product_container');

        $response = $collection->aggregate($finalQuery, ["typeMap" => ['root' => 'array', 'document' => 'array', 'object' => 'array', 'array' => 'array']]);
        $response = $response->toArray();

        $this->setTimeWithMessage($start, 'query Completed', 'bulkupload');
        if (!empty($response)) {
            if (count($response) <= $limit) {
                return ['success' => true, 'data' => $response, 'next' => false];
            } else {
                return ['success' => true, 'data' => $response, 'next' => true];
            }
        } else {
            return ['success' => false, 'message' => 'No product datsssssa'];
        }
    }

    public function apendToCommonQuery($finalQuery)
    {
        $finalQuery[] = [
            '$lookup' => [
                'from' => $this->process_data['target_marketplace'] . '_product',
                'let' => ['source_product_id' => '$source_product_id'],
                'pipeline' => [
                    [
                        '$match' =>
                        [
                            '$expr' => [
                                '$and' => [
                                    ['$eq' => [$this->di->getUser()->id, '$user_id']],
                                ],
                            ],
                        ],
                    ],
                    [
                        '$match' =>
                        [
                            '$expr' => [
                                '$and' => [
                                    ['$eq' => ['$source_product_id', '$$source_product_id']],
                                ],
                            ],
                        ],
                    ],
                    ['$project' => ['_id' => 0]],
                ],
                'as' => $this->process_data['target_marketplace'] . "_marketplace",
            ],
        ];
        return $finalQuery;
    }

    public function commonQuery()
    {
        $finalQuery = [];

        $finalQuery[] = [
            '$replaceRoot' => ['newRoot' => ['$mergeObjects' => ['$$ROOT', '$edited']]],
        ];

        $finalQuery[] = [
            '$project' => ['edited' => 0],
        ];

        $finalQuery[] = [
            '$graphLookup' => [
                "from" => "product_container",
                "startWith" => '$container_id',
                "connectFromField" => "container_id",
                "connectToField" => "group_id",
                "as" => "variants",
                "maxDepth" => 1,
                "restrictSearchWithMatch" => [
                    "user_id" => $this->di->getUser()->id
                ]
            ],
        ];

        $finalQuery[] = [
            '$match' => [
                "visibility" => 'Catalog and Search'
            ],
        ];

        return $finalQuery;
    }

    public function getProfileData()
    {
        $userId = $this->di->getUser()->id;
        $profileParams = [];

        $profileParams['filters'] = ['id' => $this->profile_id];
        $obj = new Model();
        $profileData = $obj->getProfile($profileParams);
        if (!empty($profileData['data'])) {
            $this->profile_data = $profileData['data'][0];
            return $this->profile_data;
        }
        return [];
    }
}
