<?php

/**
 * CedCommerce
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the End User License Agreement (EULA)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://cedcommerce.com/license-agreement.txt
 *
 * @category    Ced
 * @package     Ced_Shoifyhome
 * @author      CedCommerce Core Team <connect@cedcommerce.com>
 * @copyright   Copyright CEDCOMMERCE (http://cedcommerce.com/)
 * @license     http://cedcommerce.com/license-agreement.txt
 */


namespace App\Connector\Models;

use App\Core\Models\SourceModel as BaseSourceModel;


class SourceModel extends BaseSourceModel
{
    public function triggerWebhooks($data)
    {
        $data['arrival_time'] = date('c');
        if (isset($data['user_id'])) {
            $this->di->getObjectManager()->get("\App\Core\Components\Helper")
                ->setUserToken($data['user_id']);
            // $user = \App\Core\Models\User::findFirst($data['user_id']);
            // $this->di->setUser($user);
            // $decodedToken = ['role'=>'admin','user_id'=> $data['user_id']];
            // $this->di->getRegistry()->setDecodedToken($decodedToken);
        } else if (isset($data['data']['shop_domain'])) {
            $mongo = $this->di->getObjectManager()->create('\App\Core\Models\BaseMongo');
            $collection = $mongo->getCollectionForTable('user_details');
            $user = $collection->findOne(
                ['shops.myshopify_domain' => $data['data']['shop_domain']]
            );

            if (isset($user['user_id'])) {
                $this->di->getObjectManager()->get("\App\Core\Components\Helper")
                ->setUserToken($user['user_id']);
            }
        } else {
            return true;
        }

        $response = $this->di->getObjectManager()->get("\App\\" . $data['code'] . "\Models\SourceModel")->initWebhook($data);
        if ($response === 2) return 2;
        else return true;
    }

    public function triggerMeliWebhooks($data){
        $data['arrival_time'] = date('c');
        $response = $this->di->getObjectManager()->get("\App\\".$data['code']."\Models\SourceModel")->initWebhook($data);
        if($response === 2) return 2;
        else return true;
    }


    public function setupHomeUser($data)
    {


        $data['data']['data']['app_code'] = $data['rawResponse']['app_code'];

        $this->di->getLog()->logContent('post data = ' . json_encode($data), 'info', 'commence.log');
        $remoteShopId = (string)$data['data']['data']['shop_id'];
        $user = $this->di->getObjectManager()->get('App\Core\Models\User\Details')->getUserByRemoteShopId($remoteShopId, ['user_id' => 1, 'shops' => 1], $data['data']['data']['app_code']);
        $this->di->getLog()->logContent('', 'info', 'commence.log');
        /*$this->di->getLog()->logContent('validate user =' . json_encode($validateUser), 'info', 'commence.log');*/

        $shop = false;

        if (isset($user['shops'])) {
            foreach ($user['shops'] as $sh) {
                if ($sh['remote_shop_id'] == $remoteShopId) {
                    $shop = $sh;
                    break;
                }
            }
        }


        $this->di->getLog()->logContent('shop status =' . json_encode($shop), 'info', 'shopify' . DS . 'User' . DS . date("Y-m-d") . DS . 'User.log');

        if ($user && $shop) {
            $getUser = \App\Core\Models\User::findFirst([['_id' => $user['user_id']]]);
            $getUser->id = (string) $getUser->_id;
            $this->di->setUser($getUser);
            return [
                'success' => true,
                "user_was_present" => 1,
                "shop_was_present" => 1,
                "app_was_present" => 1,
                'shop' => $shop,
            ];
        } else {
            $marketplace = $data['data']['data']['marketplace'];
            $appCode = $data['data']['data']['app_code'];

            // $this->di->getLog()->logContent('Target Marketplace = ' . json_encode($target), 'info', 'shopify' . DS . 'User' . DS . date("Y-m-d") . DS . 'User.log');

            $user = $this->di->getObjectManager()->get('App\Core\Models\User\Details')->getUserByRemoteShopId((string) $data['data']['data']['shop_id'], ['user_id' => 1, 'shops' => 1]);

            if ($user) {
                $getUser = \App\Core\Models\User::findFirst([['_id' => $user['user_id']]]);
                $getUser->id = (string) $getUser->_id;
                $this->di->setUser($getUser);

                $app = [
                    "code" => $appCode
                ];

                if (isset($user['shops'])) {
                    foreach ($user['shops'] as $sh) {
                        if ($sh['remote_shop_id'] == $remoteShopId) {
                            $shop = $sh;
                            break;
                        }
                    }
                }

                $this->di
                    ->getObjectManager()
                    ->get('App\Connector\Models\User\Shop')
                    ->addApp($remoteShopId, $app, $user['user_id']);

                return [
                    'success' => true,
                    "user_was_present" => 1,
                    "shop_was_present" => 1,
                    "app_was_present" => 0,
                    'shop' => $shop,
                ];
            } else {

                $shopResponse = $this->di->getObjectManager()->get('\App\Connector\Components\ApiClient')->init($marketplace, true, $appCode)->call('/shop', [], [
                    'shop_id' => $data['data']['data']['shop_id'],
                    'app_code' => $appCode
                ]);

                $this->di->getLog()->logContent('user details. shop_id=' . $data['data']['data']['shop_id'] . ' shop response = ' . json_encode($shopResponse), 'info', 'shopify' . DS . 'User' . DS . date("Y-m-d") . DS . 'User.log');

                if (!$shopResponse['success'] || is_null($shopResponse) || empty($shopResponse)) {
                    return [
                        'success' => false,
                        'message' => isset($shopResponse['errors']) ? $shopResponse['errors'] : ' 1 Error fetching data from Shopify, Please try again later or contact our next available support member.',
                    ];
                }

                $user = \App\Core\Models\User::findFirst([['email' => $shopResponse['data']['email']]]);
                if (empty($user)) {
                    // $shopData['app_codes'] = [$appCode];
                    // $shopData['username'] = $shopResponse['data']['domain'];
                    $shopData['username'] = $shopResponse['data']['myshopify_domain'];
                    $shopData['email'] = $shopResponse['data']['email'];
                    $shopData['password'] = $this->di->getConfig()->security->default_shopify_sign;
                    $userModel = $this->di->getObjectManager()->create('\App\Core\Models\User');
                    $createUser = $userModel->createUser($shopData, 'customer', true);


                    $userModel->id = (string) $userModel->_id;
                    $this->di->setUser($userModel);

                    $responseData = [
                        'success' => true,
                        "user_was_present" => 0,
                        "shop_was_present" => 0,
                        "app_was_present" => 0,
                    ];
                } else {
                    $user = \App\Core\Models\User::findFirst([['_id' => $user->_id]]);
                    $user->id = (string) $user->_id;
                    $this->di->setUser($user);
                    $responseData = [
                        'success' => true,
                        "user_was_present" => 1,
                        "shop_was_present" => 0,
                        "app_was_present" => 0,
                    ];
                }
                /*$this->di->getLog()->logContent('Create new User ' . json_encode($createUser), 'info', 'shopify' . DS . 'User' . DS . date("Y-m-d") . DS . 'User.log');*/
                $shopData = $shopResponse['data'];
                $shopData['apps'] = [["code" => $appCode]];
                $shopData['remote_shop_id'] = $remoteShopId;
                $shopData['marketplace'] = $marketplace;

                $shopCollection = $this->di->getObjectManager()->create('\App\Core\Models\User\Details');
                $model = $this->di->getConfig()->connectors
                    ->get($marketplace)->get('source_model');
                $model = $this->di->getObjectManager()->get($model);

                //$shopData = $model->prepareShopData($shopData);
                $responseData['shop'] = $shopData;
                $shopRes = $shopCollection->addShop($shopData, false, ["email"]);
                if ($shopRes['success']) {
                    $shopData['_id'] = $shopRes['data']['shop_id'];
                    $model->addWarehouseToShop($shopData);
                }

                return $responseData;
            }
        }
    }

    public function removeWebhooksNotUsedByApps($remoteShopId)
    {
        $user = $this->di->getObjectManager()->create('\App\Core\Models\User\Details')->getUserByRemoteShopId($remoteShopId);
        if (isset($user['shops'])) {
            $shops = $user['shops'];
            $removeAppCodeWiseWebhook = [];
            $allWebhooks = [];
            $allSavedWebhhok = [];

            foreach ($shops as $sh) {
                if ($sh['remote_shop_id'] ==  $remoteShopId) {

                    foreach ($sh['apps'] as $app) {
                        $appCode = $app['code'];
                        $allWebhooks = array_merge($allWebhooks, $this->di->getConfig()
                            ->get('webhook')
                            ->get($appCode));

                        if (isset($app['webhooks'])) {
                            $webhooks = $app['webhooks'];

                            foreach ($webhooks as $key => $webhookCode) {
                                $allSavedWebhhok[$webhookCode['code']] = ['savad_data' => $webhookCode, 'app_code' => $appCode];
                            }
                        }
                    }
                    $shop = $sh;
                    break;
                }
            }
        }

        if (!empty($allSavedWebhhok)) {
            $removeWebhooks = array_diff_key($allSavedWebhhok, $allWebhooks);
            if (!empty($removeWebhooks)) {
                $finalRemoveWebhook = [];
                foreach ($removeWebhooks as $webhookId => $savedDataWithAppCode) {
                    $finalRemoveWebhook[$savedDataWithAppCode['app_code']][] = $savedDataWithAppCode['savad_data'];
                }
                foreach ($finalRemoveWebhook as $appCode => $webhook) {
                    $this->removeAppCodeWiseWebhhok($shop, $webhook, $appCode);
                }
            }
        }
    }

    public function removeAppCodeWiseWebhhok($shop, $webhooks, $appCode)
    {
        if (!$userId) {
            $userId = $this->di->getUser()->id;
        }
        $user = $this->getPhpCollection('user_details');
        $dynamoIds = [];
        $appWiseWebhookIds = [];
        foreach ($webhooks as $appCode => $savedData) {
            $appWiseWebhookIds[$appCode][] = $savedData['code'];
            $dynamoIds[] = $savedData['dynamo_webhook_id'];
        }

        foreach ($appWiseWebhookIds as $appCode => $webhookIds) {
            $user->updateOne(
                [
                    "_id" => new \MongoDB\BSON\ObjectId($userId),
                ],
                [
                    '$pull' => [
                        'shops.$[shop].apps.$[app].webhooks' => [
                            '$in' => $webhookIds
                        ]
                    ]
                ],
                [
                    'arrayFilters' => [
                        [
                            'shop.remote_shop_id' => $shop['remote_shop_id']
                        ],
                        [
                            'app.code' => $appCode
                        ]
                    ]
                ]

            );
        }

        if (!empty($dynamoIds)) {

            $responseWbhook = $this->di->getObjectManager()->get("\App\Connector\Components\ApiClient")
                ->init($shop['marketplace'], 'true')
                ->call("/webhooknew/unregister", [], ['shop_id' => $shop['remote_shop_id'], 'dynamoIds' => $dynamoIds], 'DELETE');
            return $responseWbhook;
        }
    }

    public function registerWebhooks($shop, $appCode)
    {
        /*        {

            shops : [
                {
                    "remote_shop_id" : "",
                    "apps" : [
                        {
                            "code" : "amazon_sales_channel",
                            "webhooks" : [
                                {
                                    "code" : "product_update"
                                },
                                {
                                    "code" : "product_create"
                                },
                                {
                                    "code" : "uninstall"
                                },
                                {
                                    "code" : "uninstall"
                                }
                            ]
                        }
                    ]
                }

            ]
        }*/

        $webhookHanldingApps = [];
        $registeredWebhooks = [];

        foreach ($shop['apps'] as $app) {
            if (isset($app['webhooks'])) {
                $webhookHanldingApps[$app['code']] = $app;

                foreach ($app['webhooks'] as $webhook) {
                    $registeredWebhooks[$webhook['code']] = 1;
                }
            }
        }


        if (count($registeredWebhooks)) {
            if (isset($webhookHanldingApps[$appCode])) {

                $appCodeWebhooks = $this->di->getConfig()
                    ->get('webhook')
                    ->get($appCode);
                $needToRemote = [];


                foreach ($appCodeWebhooks as $code => $savedWebhook) {
                    if (isset($registeredWebhooks[$code])) {
                        unset($appCodeWebhooks[$code]);
                    }
                }

                if (count($appCodeWebhooks)) {
                    foreach ($appCodeWebhooks as $webhookId => $webhook) {
                        if ($webhookId == 'uninstall') {
                            continue;
                        }
                        $registeredWebhookres = $this->registerWebhook($shop, $appCode, $webhookId);

                        if (isset($registeredWebhookres['success']) && $registeredWebhookres['success']) {
                            $appCodeWebhooks[$webhookId]['dynamo_webhook_id'] = $registeredWebhookres['config_save_result']['id'];
                        }
                    }


                    $this->di
                        ->getObjectManager()
                        ->get('App\Connector\Models\User\Shop')
                        ->addWebhook($shop, $appCode, $appCodeWebhooks);
                }
            } else {

                $webhooksOfRequestedApp = $this->di->getConfig()->webhook->get($appCode);
                $webhooksNeedsToBeCreated = [];


                foreach ($webhooksOfRequestedApp as $webhookId => $webhook) {
                    if ($webhookId == 'uninstall') {
                        continue;
                    }
                    if (!isset($registeredWebhooks[$webhook["code"]])) {
                        $webhooksNeedsToBeCreated[$webhookId] = $webhook;
                        $registeredWebhookres = $this->registerWebhook($shop, $appCode, $webhookId);

                        if (isset($registeredWebhookres['success']) && $registeredWebhookres['success']) {
                            $webhooksNeedsToBeCreated[$webhookId]['dynamo_webhook_id'] = $registeredWebhookres['config_save_result']['id'];
                        }
                    }
                }

                if (count($webhooksNeedsToBeCreated)) {

                    $this->di
                        ->getObjectManager()
                        ->get('App\Connector\Models\User\Shop')
                        ->addWebhook($shop, $appCode, $webhooksNeedsToBeCreated);
                }
            }
        } else {
            // register all webhooks including Uninstall webhook
            // set webhook_app_code to $appCode
            $webhooksNeedsToBeCreated = $this->di->getConfig()
                ->get('webhook')
                ->get($appCode)->toArray();
            foreach ($webhooksNeedsToBeCreated as $webhookId => $webhook) {
                if ($webhookId == 'uninstall') {
                    unset($webhooksNeedsToBeCreated[$webhookId]);
                    continue;
                }
                $registeredWebhookres = $this->registerWebhook($shop, $appCode, $webhookId);

                if (isset($registeredWebhookres['success']) && $registeredWebhookres['success']) {
                    $webhooksNeedsToBeCreated[$webhookId]['dynamo_webhook_id'] = $registeredWebhookres['config_save_result']['id'];
                }
            }
            $this->di
                ->getObjectManager()
                ->get('App\Connector\Models\User\Shop')
                ->addWebhook($shop, $appCode, $webhooksNeedsToBeCreated);
        }
        $this->removeWebhooksNotUsedByApps($shop['remote_shop_id']);
    }

    public function registerWebhook($shop, $appCode, $webhookId)
    {

        $userId = $this->di->getUser()->id;
        $awsConfig = include_once(BP . DS . 'app' . DS . 'etc' . DS . 'aws.php');

        $webhook = $this->di->getConfig()->webhook->get($shop['marketplace'])->get($webhookId) ? $this->di->getConfig()->webhook->get($shop['marketplace'])->get($webhookId)->toArray() : [];

        $appWebhook = $this->di->getConfig()->webhook->get($appCode)->get($webhookId) ? $this->di->getConfig()->webhook->get($appCode)->get($webhookId)->toArray() : [];
        $defaultWebhook = $this->di->getConfig()->webhook->get('default')->get($webhookId) ? $this->di->getConfig()->webhook->get('default')->get($webhookId)->toArray() : [];



        $webhook = array_merge($defaultWebhook, $webhook);
        $webhook = array_merge($webhook, $appWebhook);

        $webhookData = [
            'type' => 'sqs',
            'queue_config' => [
                'region' => $awsConfig['region'],
                'key' => $awsConfig['credentials']['key'],
                'secret' => $awsConfig['credentials']['secret']
            ],
            'topic' => $webhook['topic'], // depricated
            'webhook_code' => $webhook['code'],
            'queue_unique_id' => $webhook['queue_config_id'] ?? 'sqs-' . $this->di->getConfig()->app_code, // depricated
            'queue_config_id' => $webhook['queue_config_id'] ?? 'sqs-' . $this->di->getConfig()->app_code, // new index
            'format' => 'json',
            'queue_name' => isset($webhook['queue_name']) ? $this->di->getConfig()->app_code . '_' . $webhook['queue_name'] : $this->di->getConfig()->app_code . "_" . $webhookId,
            'queue_data' => [
                'type' => 'full_class',
                'class_name' => $webhook['class_name'] ?? '\App\Connector\Models\SourceModel',
                'method' => $webhook['method'] ?? 'triggerWebhooks',
                'user_id' => $userId,
                'action' => $webhook['action'],
                'code' => 'Shopifyhome', // depricated
                'queue_name' => isset($webhook['queue_name']) ? $this->di->getConfig()->app_code . '_' . $webhook['queue_name'] : $this->di->getConfig()->app_code . "_" . $webhookId,
                'app_code' => $appCode,
                'marketplace' => $shop['marketplace'] ?? ''
            ]
        ];

        $this->di->getObjectManager()->get($this->di->getConfig()
            ->connectors
            ->get($shop['marketplace'])
            ->get('source_model'))->prepareWebhookData($shop, $appCode, $webhook, $webhookData);

        $responseWbhook = $this->di->getObjectManager()->get("\App\Connector\Components\ApiClient")
            ->init($shop['marketplace'], 'true')
            ->call('/webhooknew/register', [], ['shop_id' => $shop['remote_shop_id'], 'data' => $webhookData, 'webhook' => $webhook], 'POST');

        return $responseWbhook;
    }

    public function registerUninstallWebhook($shop, $appCode)
    {

        return $this->registerWebhook($shop, $appCode, 'uninstall');
    }


    public function commenceHomeAuth($remotePostData)
    {
        $response = $this->setupHomeUser($remotePostData);


        $remotePostData['data']['data']['app_code'] = $remotePostData['rawResponse']['app_code'];

        $marketplace = $remotePostData['data']['data']['marketplace'];
        $appCode = $remotePostData['data']['data']['app_code'];

        $result = ["success" => 0];
        if ($response['success']) {
            $result['success'] = 1;
            $result['heading'] = 'Congratulations!!';
            $result['message'] = 'Welcome onboard. Your ' . $marketplace . ' store has been succesfully set up.';

            if (isset($response['shop_was_present']) && $response['shop_was_present']) {

                if (isset($response['shop']['email'])) {
                    //$this->di->getObjectManager()->get("\App\Shopifyhome\Components\Mail\Seller")->onboard($response['shop']['email']);
                }
            }
            // print_r($response);die;

            if (!$response['app_was_present']) {

                try {
                    $this->registerUninstallWebhook($response['shop'], $appCode);
                } catch (\Exception $e) {
                    $this->di->getLog()->logContent('error registering uninstall webhook for user id : ' . $this->di->getUser()->id, 'info', 'uninstallWebhook.log');
                }
            }
            $result['redirect_to_dashboard'] = 1;
        }
        return $result;
    }
}